@echo off
SETLOCAL
mode con: cols=100 lines=40
color 1B
call :logo
echo.
echo Installer Version 2.4
echo.
echo.
echo.
echo Welcome to the installation of ULTIMA VII Nitpicker Patch
echo.
echo Checking default directories...
echo.

SET instpath=C:\GOG Games\Ultima 7
echo %instpath%
if exist "%instpath%\ultima7.com" goto preinstall
SET instpath=%programfiles%\GOG Games\Ultima 7
echo %instpath%
if exist "%instpath%\ultima7.com" goto preinstall
SET instpath=%programfiles%\GOG.com\Ultima 7
echo %instpath%
if exist "%instpath%\ultima7.com" goto preinstall
SET instpath=%programfiles%\GOGcom\Ultima 7
echo %instpath%
if exist "%instpath%\ultima7.com" goto preinstall
echo No valid installation found.
goto input
echo.


:preinstall
echo Found an Ultima VII installation in %instpath%
echo Choose your poison:
echo [1] Do you want to install the Nitpicker Patch here
echo [2] or do you want to specify another directory?
SET /P "game=Please choose an option (1 or 2): "
IF "%game%"=="1" goto install
IF "%game%"=="2" goto input 

:exult
echo Copying patchfiles to the default /MODS/ folder of EXULT...
xcopy ULTIMA7\STATIC "%instpath%\mods\nitpicker" /s /i
dir
pause
copy "nitpicker.exult" "%instpath%\mods\nitpicker.cfg"
echo Done.
echo.
echo The Nitpicker's Delight Patch has been installed 
echo to be used with EXULT!
exit /b

:input
SET /P "instpath=Please enter the correct path to your ULTIMA VII installation: "
echo.
IF NOT EXIST "%instpath%\ultima7.com" GOTO input 

:install
echo Game directory set to: %instpath%
echo.
echo Choose the way you want to play the game:
echo [1] Do you play the original DOSBOX version
echo [2] or do you want to setup the Nitpicker's patch as a mod for EXULT?
SET /P "version=Please choose an option (1 or 2): "
IF "%version%"=="1" goto install2
IF "%version%"=="2" goto exult

:install2 
echo Press any key to start the installation
echo or press CTRL+C to stop this script.
@pause >nul
IF EXIST "%instpath%\U7.EXE.u7org" GOTO verify
SET "proc=installed"
echo Step 1: Backing up original files in \ULTIMA7\
ren "%instpath%\ULTIMA7.COM" ULTIMA7.COM.u7org
ren "%instpath%\U7.EXE" U7.EXE.u7org
copy "%instpath%\U7.CFG" "%instpath%\U7.CFG.sb"
ren "%instpath%\ENDGAME.EXE" ENDGAME.EXE.u7org
rem ren "%instpath%\INTRO.EXE" INTRO.EXE.u7org
rem ren "%instpath%\MAINMENU.EXE" MAINMENU.EXE.u7org
echo Done.
echo.

echo Step 2:  Backing up original files in \STATIC\
rem ren "%instpath%\STATIC\ENDGAME.DAT" ENDGAME.DAT.u7org
rem ren "%instpath%\STATIC\ENDSHAPE.FLX" ENDSHAPE.FLX.u7org
ren "%instpath%\STATIC\FACES.VGA" FACES.VGA.u7org
copy "%instpath%\STATIC\FONTS.VGA" "%instpath%\STATIC\FONTS.VGA.u7org"
rem ren "%instpath%\STATIC\GUMPS.VGA" GUMPS.VGA.u7org
rem ren "%instpath%\STATIC\INITGAME.DAT" INITGAME.DAT.u7org
copy "%instpath%\STATIC\INTRORDM.DAT" "%instpath%\STATIC\INTRORDM.DAT.sb"
rem ren "%instpath%\STATIC\INTROSND.DAT" INTROSND.DAT.u7org
ren "%instpath%\STATIC\LINKDEP1" LINKDEP1.u7org
ren "%instpath%\STATIC\LINKDEP2" LINKDEP2.u7org
ren "%instpath%\STATIC\MAINSHP.FLX" MAINSHP.FLX.u7org
copy "%instpath%\STATIC\MT32MUS.DAT" "%instpath%\STATIC\MT32MUS.DAT.sb"
copy "%instpath%\STATIC\MT32SFX.DAT" "%instpath%\STATIC\MT32SFX.DAT.sb"
rem ren "%instpath%\STATIC\POINTERS.SHP" POINTERS.SHP.u7org
ren "%instpath%\STATIC\TEXT.FLX" TEXT.FLX.u7org
ren "%instpath%\STATIC\TFA.DAT" TFA.DAT.u7org
copy "%instpath%\STATIC\U7INTRO.TIM" "%instpath%\STATIC\U7INTRO.TIM.sb"
ren "%instpath%\STATIC\USECODE" USECODE.u7org
echo Done.
echo.

echo Step 3: Copying patchfiles...
xcopy ULTIMA7 "%instpath%\" /s
echo Done.
echo.
echo Step 4: Initial Configuration Settings.
echo Which keyboard do you use?
echo [1] US-AMERICAN layout (SHIFT+2=@)
echo [2] BRITISH layout (SHIFT+3=)
echo [3] FRENCH layout (SHIFT+1=&)
echo [4] SWISS layout (SHIFT+1=+)
echo [5] GERMAN layout (SHIFT+1=!)
SET /P "kb=Please choose an option (1-5): "
IF "%kb%"=="1" SET tasten=american
IF "%kb%"=="2" SET tasten=british && COPY "%instpath%\U7Hack_deCH.EXE" "%instpath%\U7.EXE"
IF "%kb%"=="3" SET tasten=french && COPY "%instpath%\U7Hack_enGB.EXE" "%instpath%\U7.EXE"
IF "%kb%"=="4" SET tasten=swiss && COPY "%instpath%\U7Hack_deCH.EXE" "%instpath%\U7.EXE"
IF "%kb%"=="5" SET tasten=german && COPY "%instpath%\U7Hack_deDE.EXE" "%instpath%\U7.EXE"
echo.
echo What sound would you like to use?
echo [1] original Soundblaster
echo [2] MIDI-Patch by Newton Dragon
SET /P "snd=Please choose option 1 or 2: "
IF "%snd%"=="1" SET sound=original && GOTO end
IF "%snd%"=="2" SET sound=MIDI
del "%instpath%\U7.CFG" 
del "%instpath%\STATIC\INTRORDM.DAT"
del "%instpath%\STATIC\MT32MUS.DAT"
del "%instpath%\STATIC\MT32SFX.DAT"
del "%instpath%\STATIC\U7INTRO.TIM"
copy "%instpath%\STATIC\*.midi" "%instpath%\STATIC\*."
copy "%instpath%\*.midi" "%instpath%\*."

GOTO end



:verify
echo The script found backup files from an earlier patchinstallation.
echo Do you want the patch to be removed and the installation restored 
echo to the original setup?
SET /P "check=Please type 'yes' to remove the patch: "
IF "%check%"=="yes" GOTO remove
GOTO end



:remove
SET "proc=removed"
echo.
echo Patch is being removed
del "%instpath%\ENDGAME.EXE"
rem del "%instpath%\INTRO.EXE"
rem del "%instpath%\MAINMENU.EXE"
del "%instpath%\U7.EXE"
del "%instpath%\U7Hack_deCH.EXE"
del "%instpath%\U7Hack_deDE.EXE"
del "%instpath%\U7Hack_enGB.EXE"
del "%instpath%\U7Hack_frFR.EXE"
del "%instpath%\U7Hack_enUS.EXE"
del "%instpath%\STARTU7.COM"
del "%instpath%\ULTIMA7.COM"
del "%instpath%\U7.CFG.midi"
del "%instpath%\U7.CFG"
del "%instpath%\_toggle_*.cmd
rem del "%instpath%\STATIC\ENDGAME.DAT"
rem del "%instpath%\STATIC\ENDSHAPE.FLX"
del "%instpath%\STATIC\FACES.VGA"
del "%instpath%\STATIC\FONTS.VGA"
del "%instpath%\STATIC\FONTS.VGA.FRK"
del "%instpath%\STATIC\FONTS.VGA.SRF"
rem del "%instpath%\STATIC\GUMPS.VGA"
rem del "%instpath%\STATIC\INITGAME.DAT"
rem del "%instpath%\STATIC\INTROSND.DAT"
del "%instpath%\STATIC\INTRORDM.DAT"
del "%instpath%\STATIC\MT32MUS.DAT"
del "%instpath%\STATIC\MT32SFX.DAT"
del "%instpath%\STATIC\U7INTRO.TIM"
del "%instpath%\STATIC\INTRORDM.DAT.midi"
del "%instpath%\STATIC\MT32MUS.DAT.midi"
del "%instpath%\STATIC\MT32SFX.DAT.midi"
del "%instpath%\STATIC\U7INTRO.TIM.midi"
del "%instpath%\STATIC\LINKDEP1"
del "%instpath%\STATIC\LINKDEP2"
del "%instpath%\STATIC\MAINSHP.FLX"
rem del "%instpath%\STATIC\POINTERS.SHP"
del "%instpath%\STATIC\TEXT.FLX"
del "%instpath%\STATIC\TFA.DAT"
del "%instpath%\STATIC\USECODE"

echo.
echo Restoring original backup files
ren "%instpath%\*.u7org" *.
ren "%instpath%\U7.CFG.sb" *.
ren "%instpath%\STATIC\*.u7org" *.
ren "%instpath%\STATIC\*.sb" *.


:end
set /p build=<"%instpath%\ver.de"
echo.
echo The Nitpicker's Patch version %build% for ULTIMA VII
IF "%proc%"=="installed" ECHO configured for %tasten%keyboard layout and %sound%sound
echo has been %proc% successfully.
IF "%proc%"=="removed" del "%instpath%\ver.de" 
echo Press any key to exit the script.
@pause >nul
exit /b

:logo
echo   ================================================================================================
echo  ^|   ___  ___  ___   _________  ___  _____ ______   ________          ___      ___ ___  ___       ^|
echo  ^|  ^|\  \^|\  \^|\  \ ^|\___   ___\\  \^|\   _ \  _   \^|\   __  \        ^|\  \    /  /^|\  \^|\  \      ^|
echo  ^|  \ \  \\\  \ \  \\^|___ \  \_\ \  \ \  \\\__\ \  \ \  \^|\  \       \ \  \  /  / ^| \  \ \  \     ^|
echo  ^|   \ \  \\\  \ \  \    \ \  \ \ \  \ \  \\^|__^| \  \ \   __  \       \ \  \/  / / \ \  \ \  \    ^|
echo  ^|    \ \  \\\  \ \  \____\ \  \ \ \  \ \  \    \ \  \ \  \ \  \       \ \    / /   \ \  \ \  \   ^|
echo  ^|     \ \_______\ \_______\ \__\ \ \__\ \__\    \ \__\ \__\ \__\       \ \__/ /     \ \__\ \__\  ^|
echo  ^|      \^|_______^|\^|_______^|\^|__^|  \^|__^|\^|__^|     \^|__^|\^|__^|\^|__^|        \^|__^|/       \^|__^|\^|__^|  ^|
echo  ^|                                                                                                ^|
echo  ^|              _______ _            ____  _            _       _____       _                     ^|
echo  ^|             ^|__   __^| ^|          ^|  _ \^| ^|          ^| ^|     / ____^|     ^| ^|                    ^|
echo  ^|                ^| ^|  ^| ^|__   ___  ^| ^|_) ^| ^| __ _  ___^| ^| __ ^| ^|  __  __ _^| ^|_ ___               ^|
echo  ^|                ^| ^|  ^| '_ \ / _ \ ^|  _ ^<^| ^|/ _` ^|/ __^| ^|/ / ^| ^| ^|_ ^|/ _` ^| __/ _ \              ^|
echo  ^|                ^| ^|  ^| ^| ^| ^|  __/ ^| ^|_) ^| ^| (_^| ^| (__^|   ^<  ^| ^|__^| ^| (_^| ^| ^|^|  __/              ^|
echo  ^|                ^|_^|  ^|_^| ^|_^|\___^| ^|____/^|_^|\__,_^|\___^|_^|\_\  \_____^|\__,_^|\__\___^|              ^|
echo  ^|                                                                                                ^|
echo   ================================================================================================
echo.

goto :eof